#!/bin/bash

date "+%H:%M:%S"

if [ $# -ne 1 ]; then 
	echo utilizare: $0 file.baby;
	exit;
fi
export nume_fisier=$1
ext=${nume_fisier##*.}
if [ $ext != 'baby' ]; then
	echo Nu este baby;
	exit;
fi

if [ ! -e $nume_fisier ]; then
	echo N-am dat de baby;
	exit;
fi

ultimefisier=$(tail -2 $nume_fisier)
ultimenonstd=$(tail -2 nonstd.baby)
if [ "$ultimefisier" = "$ultimenonstd" ]; then 
	echo nonstd.baby este deja inclus;
else
	if [ -e 'nonstd.baby' ]; then
		cat nonstd.baby >> $1;
	else
		echo N-am dat de nonstd.baby;
	fi
fi

# Substituții preliminare prelucrării fișierului baby
# Pot dura ceva mai mult. Prima este mai importantă.
# În loc de #sed trebuie sed pentru ca să opereze substituțiile

sed -i 's/^<b>\([A-ZĂÎÂȘȚÁÉÍÓÚ /()]\{4,\}\)\([a-zăîâșțáéíóú /(),.~-]\+\)<\/b>/<b>\1<\/b>\2/' $1

# Html break în loc de \r\n [Aceasta să fi fost la origine intenția?]
#sed -i 's/\\r\\n/<br>/g' $1

# Probabil litere românești ș.a. cu urme de fostă codificare stil LaTeX
#sed -i 's/A\\/A/g' $1
#sed -i 's/Ă\\/Ă/g' $1
#sed -i 's/Â\\/Â/g' $1
#sed -i 's/Î\\/Î/g' $1
#sed -i 's/Ș\\/Ș/g' $1
#sed -i 's/\\ț/ț/g' $1
#sed -i 's/Ț\\/Ț/g' $1
#sed -i 's/ö\\/ö/g' $1
#sed -i 's/\\ö/ö/g' $1
#sed -i 's/\\Ö/Ö/g' $1
#sed -i 's/\\ü/ü/g' $1
#sed -i 's/\\Ü/Ü/g' $1

# În rest pare în ordine să punem ' unde este backslash
#sed -i 's/\\\x27/\x27/g' $1
#sed -i 's/d\\ /d\x27/g' $1
#sed -i 's/\\/\x27/g' $1

date '+%H:%M:%S'
