#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
Extract from DEX online SQL dump the list with the forms of
the Romanian words (a word list).
Created at: 2010-01-11
This version of the tool is just an idea.
This version is conceived specifically for dexonline sqldump.
Author: Mihail-Radu Solcan
Visit http://www.filosofie.unibuc.ro/~solcan/wt/wtc/gnu/index.html
"""
__copyright__ = "GPL"
__revision__ = "1"
__date__ = "2010-01-11"

import sys
import re
import os
import time

# Verifică sufixul numelui fișierului
def este_sql(rand_ltx):
    """ Funcţie booleană pentru sufixul fișierului prelucrat """
    return rand_ltx.endswith('.sql')

# Funcţiile următoare servesc la identificarea unor comenzi
# din documente SQL. Presupunem că ele apar pe prima poziţie din
# rând.

def este_wl(rand_ltx):
    """ Funcţie booleană pentru liste de cuvinte """
    return rand_ltx.startswith('INSERT INTO `wordlist` VALUES')

# În sursa StarDict rândurile albe sunt, de fapt, comenzi.
# Rândul alb cere construirea unei noi intrări în dicționar.
def este_rand_alb(rand_ltx):
    """ Funcţie booleană pentru a stabili dacă rândul este alb """
    if rand_ltx.startswith('\n'):
        return 1
    else:
        return 0

def subst_final_sql_insert(abc):
    """ Substituţie pentru finalul de la INSERT INTO """
    verbal = re.compile('\);$')
    abc = verbal.sub('\n', abc)
    return abc

# Extragerea listelor de cuvinte într-un fișier csv
def creeaza_csv_wl(lista_in):
    """ Se construiește un fișier csv  """
    """ campuri_csv ='wl_form,wl_neaccentuat,wl_utf8_general,wl_lexem,wl_analyse,wl_variant' """
    lista_out = [] # iniţializarea variabilei pentru rezultatul preprocesării
    for linie in lista_in:
        if not este_rand_alb(linie):
            linie = linie.strip()   # elimină spaţiile albe iniţiale/finale
        if este_wl(linie):
            linie = linie.replace('INSERT INTO `wordlist` VALUES (', '')
            linie = linie.replace('),(', '\n')
            linie = subst_final_sql_insert(linie)
            lista_out += [linie]
    return lista_out

# S-a terminat definirea de funcţii.

# În urma apelului din linia de comandă la momentul
print time.clock()
# începe procesul de prelucrare efectivă a fişierului SQL
if __name__ == "__main__":
    nume_fisier_in = sys.argv[1]        # preluarea numelui fişierului SQL
    if este_sql(nume_fisier_in):
        fisier = open(nume_fisier_in,'r')# deschiderea fişierului SQL
    else:
        print 'No sql dump!'
        exit()
    text_sql = fisier.readlines()       # preluarea conţinutului fişierului
    fisier.close()                      # închiderea fişierului SQL

# Este creat un fișier temporar de tip csv
# În fișierul csv sunt preluate listele de cuvinte din fișierul SQL
    text_csv_wl = creeaza_csv_wl(text_sql)
    nume_fisier_wl_all = nume_fisier_in.replace('.sql', '-wl-all.csv')
    nume_fisier_wl = nume_fisier_in.replace('.sql', '-wl.csv')
    fisier_wl_all = open(nume_fisier_wl_all,'w')
    for i in range(len(text_csv_wl)): 
        fisier_wl_all.write(text_csv_wl[i])
    fisier_wl_all.close()
    # În fișierul mic, păstrăm numai două câmpuri (inversate):
    # numărul de identificare al lexemului și formele sale
    doua_campuri = os.system('cat ' + nume_fisier_wl_all + '| sed \'s/.*,\(.*\),\([0-9]*\),[0-9]*,[0-9]*$/\\2,\\1/g\' | sort -g > ' + nume_fisier_wl + '')
    sterge_wl_all = os.system('rm -vf ' + nume_fisier_wl_all + '')
    print 'stardex-tools use `%s`' % (nume_fisier_wl)

# La momentul
print time.clock()
# Este gata.
